% Data Mining : TP Parzen et knn
% Auteurs : Florian Boitrel - Maxime Chambreuil
% Date : 14 Mai 2003
%
% ypred = knn ( xapp , yapp , xtest , h )
%
% ENTREE :
% xapp : Matrice des points d apprentissage
% yapp : Classe des points d apprentissage ( 0 ou 1 )
% xtest : Matrice des points de test
% k : Nombre de plus proche voisin
%
% SORTIE :
% ypred : classe des points de test
%

function ypred=knn(xapp,yapp,xtest,k)

% On calcule la matrice des distances entre les 
% points de tests et les point d apprentissage

d = distance(xtest, xapp,1);

ypred = [];

for i=1:size(xtest,1)
     [sorted indice] = sort(d(i,:));
     som = sum(yapp(indice(1:k)));
     if (som < k/2 )
         ypred(i) = 0;
     else
         ypred(i) = 1;
     end
end

